/**
 ** vimanCntrlTaskCodels.cc
 **
 ** Codels used by the control task vimanCntrlTask
 **
 ** Author: 
 ** Date: 
 **
 **/

#include <portLib.h>

#include "server/vimanHeader.h"


/*------------------------------------------------------------------------
 * vimanDeactivateTrackingCntrl  -  control codel of CONTROL request DeactivateTracking
 *
 * Description:    
 * Report: OK
 *                 S_viman_VIMAN_UNINITIALIZED
 *
 * Returns:    OK or ERROR
 */

//STATUS
//vimanDeactivateTrackingCntrl(int *report)
//{
//  SDI_F->flagTracking= VIMAN_DISABLE;
//  return OK;
//}

/*------------------------------------------------------------------------
 * vimanGetObjectPoseCntrl  -  control codel of CONTROL request GetObjectPose
 *
 * Description:    
 * Report: OK
 *                 S_viman_VIMAN_UNINITIALIZED
 *                 S_viman_CANNOT_FIND_OBJECT
 *
 * Returns:    OK or ERROR
 */

STATUS
vimanGetObjectPoseCntrl(VimanString *objectName, int *report)
{
  int i=0;
  if( SDI_F->vimanInitIsDone == VIMAN_DISABLE) {
    *report =  S_viman_VIMAN_UNINITIALIZED;
    return ERROR;
  }
  for(i=0; i<SDI_F->objectArray.nbObjects; i++) {
    if( strcmp(SDI_F->objectArray.objects[i].name,objectName->str)==0) {
    
      SDI_F->thetaMat.nx = SDI_F->objectArray.objects[i].thetaMatRob.nx;
      SDI_F->thetaMat.ny = SDI_F->objectArray.objects[i].thetaMatRob.ny;
      SDI_F->thetaMat.nz = SDI_F->objectArray.objects[i].thetaMatRob.nz;
	          						 
      SDI_F->thetaMat.ox = SDI_F->objectArray.objects[i].thetaMatRob.ox;
      SDI_F->thetaMat.oy = SDI_F->objectArray.objects[i].thetaMatRob.oy;
      SDI_F->thetaMat.oz = SDI_F->objectArray.objects[i].thetaMatRob.oz;
      								 
      SDI_F->thetaMat.ax = SDI_F->objectArray.objects[i].thetaMatRob.ax;
      SDI_F->thetaMat.ay = SDI_F->objectArray.objects[i].thetaMatRob.ay;
      SDI_F->thetaMat.az = SDI_F->objectArray.objects[i].thetaMatRob.az;
      								 
      SDI_F->thetaMat.px = SDI_F->objectArray.objects[i].thetaMatRob.px;
      SDI_F->thetaMat.py = SDI_F->objectArray.objects[i].thetaMatRob.py;
      SDI_F->thetaMat.pz = SDI_F->objectArray.objects[i].thetaMatRob.pz;  
    }    
  }

  if(i == SDI_F->objectArray.nbObjects-1) {
    *report = S_viman_CANNOT_FIND_OBJECT;
    return ERROR;
  }
  return OK;
}

/*------------------------------------------------------------------------
 * vimanStopCntrl  -  control codel of CONTROL request Stop
 *
 * Description:    
 * Report: OK
 *                 S_viman_VIMAN_UNINITIALIZED
 *
 * Returns:    OK or ERROR
 */

STATUS
vimanStopCntrl(int *report)
{
  SDI_F->flagTracking= VIMAN_DISABLE;
  return OK;
}




/*------------------------------------------------------------------------
 * vimanGetFullObjectPoseCntrl  -  control codel of CONTROL request GetFullObjectPose
 *
 * Description:    
 * Report: OK
 *                 S_viman_VIMAN_UNINITIALIZED
 *                 S_viman_CANNOT_FIND_OBJECT
 *
 * Returns:    OK or ERROR
 */

STATUS
vimanGetFullObjectPoseCntrl(VimanString *objectName, int *report)
{

  int i=0;
  if( SDI_F->vimanInitIsDone == VIMAN_DISABLE) {
    *report =  S_viman_VIMAN_UNINITIALIZED;
    return ERROR;
  }
  for(i=0; i<SDI_F->objectArray.nbObjects; i++) {
    if( strcmp(SDI_F->objectPublicArray.objects[i].name,objectName->str)==0) {
      memcpy(&(SDI_F->objectPublic), &(SDI_F->objectPublicArray.objects[i]), sizeof(VimanObjectPublic));
    }    
  }

  if(i == SDI_F->objectArray.nbObjects-1) {
    *report = S_viman_CANNOT_FIND_OBJECT;
    return ERROR;
  }
   return OK;
}




